<?php

/** Test the Verify */
class test_verify extends PHPUnit_Framework_TestCase
{
  ///////////////
  //   DATES   //
  ///////////////
  public function test_is_datetimeSQL1 ()
  {
    $verify = new \verify ();
    $res = $verify->is_datetimeSQL ("2017-04-13 22:55:17");
    $this->assertSame ($res, true);
  }

  public function test_is_datetimeSQL2 ()
  {
    $verify = new \verify ();
    $res = $verify->is_datetimeSQL ("2017-13-55 22:55:17");
    $this->assertSame ($res, false);
  }

  public function test_staticIs_datetimeSQL1 ()
  {
    $res = \verify::staticIs_datetimeSQL ("2017-04-13 22:55:17");
    $this->assertSame ($res, true);
  }

  public function test_staticIs_datetimeSQL2 ()
  {
    $res = \verify::staticIs_datetimeSQL ("2017-13-55 22:55:17");
    $this->assertSame ($res, false);
  }
  public function test_is_dateSQL1 ()
  {
    $verify = new \verify ();
    $res = $verify->is_dateSQL ("2017-04-13");
    $this->assertSame ($res, true);
  }

  public function test_is_dateSQL2 ()
  {
    $verify = new \verify ();
    $res = $verify->is_dateSQL ("2017-13-55");
    $this->assertSame ($res, false);
  }

  public function test_staticIs_dateSQL1 ()
  {
    $res = \verify::staticIs_dateSQL ("2017-04-13");
    $this->assertSame ($res, true);
  }

  public function test_staticIs_dateSQL2 ()
  {
    $res = \verify::staticIs_dateSQL ("2017-13-55");
    $this->assertSame ($res, false);
  }


  /////////////////
  //   STRINGS   //
  /////////////////
  public function test_staticIsAllowedChars_1 ()
  {
    $res = \verify::staticIsAllowedChars ("éléphant", "abcd");
    $this->assertSame ($res, false);
  }

  public function test_staticIsAllowedChars_2 ()
  {
    $res = \verify::staticIsAllowedChars ("éléphant", "anhplté");
    $this->assertSame ($res, true);
  }

  /////////////////
  //   NUMBERS   //
  /////////////////
  public function test_staticIs_integer1 ()
  {
    $res = \verify::staticIs_integer ("2017-04-13 22:55:17");
    $this->assertSame ($res, false);
  }

  public function test_staticIs_integer2 ()
  {
    $res = \verify::staticIs_integer ("01234");
    $this->assertSame ($res, true);
  }

  public function test_staticIs_integer3 ()
  {
    $res = \verify::staticIs_integer ("0x1234");
    $this->assertSame ($res, false);
  }

  public function test_staticIs_integer4 ()
  {
    $res = \verify::staticIs_integer ("");
    $this->assertSame ($res, false);
  }

  ////////////////
  //   EMAILS   //
  ////////////////

  /////////////
  //   URL   //
  /////////////
  public function test_is_url1 ()
  {
    $verify = new \verify ();
    $res = $verify->is_url ("invalid");
    $this->assertsame ($res, false);
  }

  public function test_is_url2 ()
  {
    $verify = new \verify ();
    $res = $verify->is_url ("http://valid");
    $this->assertsame ($res, true);
  }

  public function test_staticIs_url1 ()
  {
    $res = \verify::staticIs_url ("invalid");
    $this->assertsame ($res, false);
  }

  public function test_staticIs_url2 ()
  {
    $res = \verify::staticIs_url ("http://valid");
    $this->assertsame ($res, true);
  }

  ////////////////
  //   OTHERS   //
  ////////////////
  public function test_is_UUID1 ()
  {
    $verify = new \verify ();
    $res = $verify->is_UUID ("ca39275f-9224-425f-ba94-efce2aa5b52c");
    $this->assertsame ($res, true);
  }

  public function test_is_UUID2 ()
  {
    $verify = new \verify ();
    $res = $verify->is_UUID ("zz39275f-9224-425f-ba94-efce2aa5b52c");
    $this->assertsame ($res, false);
  }

  public function test_is_UUID3 ()
  {
    $verify = new \verify ();
    $res = $verify->is_UUID ("2c");
    $this->assertsame ($res, false);
  }

  public function test_staticis_UUID1 ()
  {
    $res = \verify::staticis_UUID ("ca39275f-9224-425f-ba94-efce2aa5b52c");
    $this->assertsame ($res, true);
  }

  public function test_staticis_UUID2 ()
  {
    $res = \verify::staticis_UUID ("zz39275f-9224-425f-ba94-efce2aa5b52c");
    $this->assertsame ($res, false);
  }

  public function test_staticis_UUID3 ()
  {
    $res = \verify::staticis_UUID ("2c");
    $this->assertsame ($res, false);
  }
}
