<?php
/** DomFramework
    @package domframework
    @author Dominique Fournier <dominique@fournier38.fr> */

/** The rate limit abstract class */
class ratelimit
{
  /** The maximum number of entries by specified unit time */
  public $maxEntries = 10;
  /** The unit time in seconds */
  public $unittime = 60;

  /** The function set a rate-limit
    * @param string $name The rate-limit object to set
    * @return bool true if the rate-limit is not overloaded
    *              false if the rate-limit is overloaded
    */
  public function set ($name)
  {
    throw new \Exception (dgettext("domframework",
                                  "ratelimit : no valid ratelimiter available"),
                         500);
  }

  /** The function delete a rate-limit
    * @param string $name The rate-limit object to del
    * @return bool
    */
  public function del ($name)
  {
    throw new \Exception (dgettext("domframework",
                                  "ratelimit : no valid ratelimiter available"),
                         500);
  }

  /** The function clean the storage
    * @return bool
    */
  public function clean ()
  {
    throw new \Exception (dgettext("domframework",
                                  "ratelimit : no valid ratelimiter available"),
                         500);
  }
}
